// OSC
OscP5 sOsc;
NetAddress remoteLocation; 


// ====================================================
// initOsc()
//
// ====================================================
void initOsc() 
{
  remoteLocation  = new NetAddress(myRemoteHost, myRemotePort); 
  sOsc  = new OscP5(this, myListeningPort);
}

// ====================================================
// oscEvent()
// ====================================================
void oscEvent(OscMessage oscIn) 
{
 //  println(oscIn.addrPattern());
   lastReceivedCommand = oscIn.addrPattern();
   if(oscIn.checkTypetag("s")) 
   {
      lastReceivedMessage = oscIn.get(0).stringValue();
   }
}

// ====================================================
// sendConnect()
// ====================================================
void sendConnect()
{
   OscMessage oscMsg = sOsc.newMsg(verbConnect);
   oscMsg.add(myUserName);
   send(oscMsg);
  isConnect = true;
}


// ====================================================
// sendDisconnect()
// ====================================================
void sendDisconnect()
{
  send(sOsc.newMsg(verbDisconnect));
  isConnect = false;
}


// ====================================================
// changeClientScript()
// ====================================================
void changeClientScript(String s)
{
  OscMessage oscMsg = sOsc.newMsg(verbChangeSceneScript);
  oscMsg.add(s);
  oscMsg.add(isCallInit);
  if (isCallInit)
  {
    println("- call init");
    isCallInit = false;
  }
  send(oscMsg);
}

// ====================================================
// sendNewScript()
// ====================================================
boolean sendNewScript()
{
  if (pathScript != null)
  {
    String lines[] = loadStrings(pathScript);
    if (lines != null)
    {
      String script = "";
      for (int i=0 ; i<lines.length ; i++)
        script += lines[i]+"\n";
      changeClientScript(script);
    
//    println(". sendNewScript()");
//    println(script);

      return true;
    }
  }

  return false;

}



// ====================================================
// sendMouseMoved()
// ====================================================
void sendMouseMoved(float x, float y)
{
  OscMessage oscMsg = sOsc.newMsg(verbMouseMoved);
  oscMsg.add(x);
  oscMsg.add(y);
  send(oscMsg);
}

// ====================================================
// sendMousePressed()
// ====================================================
void sendMousePressed(float x, float y, int btn)
{
  OscMessage oscMsg = sOsc.newMsg(verbMousePressed);
  oscMsg.add(x);
  oscMsg.add(y);
  oscMsg.add(btn);
  send(oscMsg);
}

// ====================================================
// send()
// ====================================================
void send(OscMessage oscMsg)
{
  sOsc.send(oscMsg, remoteLocation);
}

// ====================================================
// sendTestMessage()
// ====================================================
void sendTestMessage()
{
  OscMessage oscMsg = sOsc.newMsg("/VF/test/message/from/processing");
  send(oscMsg);
}



