class VirtualScreen
{
  float theMouseX,theMouseY; // normalized
  float x,y,w,h;

  VirtualScreen(float x, float y, float w, float h)
  {
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
  }  

  void draw()
  {
//    pushStyle();

    if (mouseInside())
    {
      noCursor();
      stroke(1,1,1);
    }
    else
    {
      cursor();
      stroke(1,0,0);
    }
//    noFill();
    rectMode(CORNER);
    rect(x,y,w,h);    

    if (mouseInside())
    {
      noStroke();
      fill(255,0,0);
      ellipseMode(CENTER);
      ellipse(mouseX,mouseY,10,10);
    }
//    popStyle();
  }


  boolean mouseInside()
  {
    return ( (mouseX >= x) && (mouseX <= (x+w)) && (mouseY >= y) && (mouseY <= (y+h)) );
  }

  void mouseMoved()
  {
    if (mouseInside())
    {
      theMouseX = (mouseX - x) / w;
      theMouseY = (mouseY - y) / h;
    
      sendMouseMoved(theMouseX, theMouseY);
    }  
  }


  void mousePressed()
  {
    if (mouseInside())
    {
      sendMousePressed(theMouseX, theMouseY, mouseButton);
    }
  }
};


